#include <xc.h>
//#include <htc.h>
#include "Library.h" 
#include "FT8xx.h"
#include <string.h>
#include <stdint.h> // for Uint8/16/32 and Int8/16/32 data types
#include <stdio.h>
#include <stdlib.h>
#include "configbits.h"

//#define _XTAL_FREQ 12000000      // Required for _delay() function, internal OSC Max


// PIC configuration definitions

// IF INTERNAL OSCILLATOR (NO CRYSTAL))
//#define FOSC 80000000 //80 MHZ

//#pragma config FNOSC = 80000000  // Oscillator Selection bits (INTOSC oscillator: CLKOUT function on RA4/OSC2/CLKOUT pin, I/O function on RA5/OSC1/CLKIN)
                                                    
//#pragma config PWRTE = OFF                                                     // Power-up Timer Enable bit (PWRT disabled)
//#pragma config MCLRE = EXTMCLR                                                  // MCLR Pin Function Select bit (MCLR pin function is MCLR)
//#pragma config BOR = ON                                                       // Brown-out Reset Selection bits (BOR enabled)
//RCON

#define CS_LCD LATDbits.LATD4
//#define MISO LATDbits.LATD2
//#define MOSI LATDbits.LATD3
//#define SCK  LATDbits.LATD1


//----------------------------------- MCU Layer -------------------------------//   
// Functions to talk to PIC registers. If porting the code to a different PIC 
// or to another MCU, these should be modified to suit the registers of the 
// selected MCU.

// ------------------- MCU specific initialization  ----------------------------

void MCU_Init(void)
{
 
    AD1PCFG = 0xFFFF;           // set all pins to digital
    
    TRISDbits.TRISD4 = 0;                                                       // CS_LCD
    TRISDbits.TRISD5 = 0;                                                       // PD pin
    TRISDbits.TRISD3=0;                                                         // MOSI
    TRISDbits.TRISD2 = 0;                                                       // MISO
    TRISDbits.TRISD1 = 1;                                                       // SCK

    
    DDPCON = 0x0000;            // disable JTAG
    IEC0bits.SPI3EIE = 0;       // SPI interrupts disabled
    IEC0bits.SPI3RXIE = 0;
    IEC0bits.SPI3TXIE = 0;
    IFS0bits.SPI3EIF = 0;
    IFS0bits.SPI3RXIF = 0;
    IFS0bits.SPI3TXIF = 0;
    SPI3CONbits.ON = 0;         // Turn off SPI module
     
    SPI3BUF = 0;                // Clear the receive buffer
     
    SPI3BRG = 19;                // FSCK = 1MHz
     //SPI4BRG = 0;                // FSCK = 20MHz (once we get it working)
     
    SPI3STATbits.SPIROV = 0;    // Clear overflow flag
     
     
    /* SPI2CON settings */
    SPI3CONbits.FRMEN = 0;      // Framed SPI support is disabled
    SPI3CONbits.SIDL = 0;       // Continue operation in IDLE mode
    SPI3CONbits.DISSDO = 0;     // SDO1 pin is controlled by the module
    //SPI2CONbits.MODE16 = 0;     // 16 bit mode
    //SPI2CONbits.MODE32 = 1;
    SPI3CONbits.CKP = 0;        // Idle state for clock is low, active state is low, on rising edge
    SPI3CONbits.SSEN = 0;       // Not in slave mode
    SPI3CONbits.MSTEN = 1;      // Master mode
    SPI3CONbits.SMP = 0;        // Input data sampled at the middle of data output time
    
    SPI3CONbits.CKE = 1;        //changed it from 0       // Output data changes on transition from idle to active
     
    SPI3CONbits.ON = 1;         // Turn module on
    
}  
// ########################### GPIO CONTROL ####################################

// --------------------- Chip Select line low ----------------------------------
void MCU_CSlow(void)
{
    CS_LCD = 0;                                                         // CS# line low
    Nop();
}  

// --------------------- Chip Select line high ---------------------------------
void MCU_CShigh(void)
{
    Nop();
    CS_LCD = 1;                                                         // CS# line high
}

// -------------------------- PD line low --------------------------------------
void MCU_PDlow(void)
{
    LATDbits.LATD5 = 0;                                                         // PD# line low
}

// ------------------------- PD line high --------------------------------------
void MCU_PDhigh(void)
{
    LATDbits.LATD5 = 1;                                                         // PD# line high
}

// ################################# SPI #######################################

// --------------------- SPI Send and Receive ----------------------------------
uint8_t MCU_SPIReadWrite(uint8_t DataToWrite)
{
    uint8_t DataRead = 0;
    
    SPI3BUF = DataToWrite;                                                    // Write data to SPI data register                          
    while(!SPI3STATbits.SPIRBF);                                                // Wait for completion of the SPI transfer
    DataRead = SPI3BUF; 
    return DataRead;
}

void MCU_Delay_20ms(void)
{ 
    int dly = 0;   
    while(dly < 28420){
        dly++;
    }
    
} 
  
void MCU_Delay_500ms(void)
{
    int dly = 0;                                                      
    
    for(dly =0; dly < 25; dly++)
    {
        MCU_Delay_20ms();
    }
}
